--  ExtendedActionBar by Tinsus
--  (c) Tinsus - on every change send me a mail via curse.com!
--
--  For other informations look at ExtendedActionBar.toc

local EEAB = {
	version = string.sub("v.2.0", 2),
	Path = "Interface/Addons/ExtendedActionBar/",
	Language = "ENUS",
}

--[===[@debug@
EEAB.debugmode = true
EEAB.version = "@"..EEAB.version
--@end-debug@]===]

_G.EEAB = EEAB

SLASH_ExtendedActionBar1 = "/EEAB"
SLASH_ExtendedActionBar2 = "/eeab"
SLASH_ExtendedActionBar3 = "/ExtendedActionBar"
SLASH_ExtendedActionBar4 = "/extendedactionbar"

SlashCmdList["ExtendedActionBar"] = function(editBox, command)
	command = string.lower(command)

	if command == "show" or command == "" then
		ToggleUIFrame(ExtendedActionBar_Optionen)

	elseif command == "reload" then
		EEAB.io("Reloading...")

		EEAB.int = nil

		local files = {"ExtendedActionBar", "lua/IO", "lua/Kernel", "lua/Button", "lua/Bar", "lua/hook", "lua/Bindings", "lua/Config", "language/"..(EEAB.Language), "lua/Actionhelpers", "lua/DoItem", "lua/SetItem", "lua/MoveItem", "lua/Tooltip", "lua/DataManager", "lua/Loader"}

		for _, path in ipairs(files) do
			dofile((EEAB.Path)..path..".lua")
		end

		EEAB.SetHooks()

		EEAB.io(2)

	
	elseif command == "helper1" then
		if EEAB.MacroSkill then
			ExecuteMacroLine("/cast "..tostring(EEAB.MacroSkill))
		end

		EEAB.MacroSkill = nil

	elseif command == "helper2" then
		if EEAB.MakroID then
			SetTitleRequest(EEAB.MakroID)
		end

		EEAB.MakroID = nil
	else
		EEAB.io("#1# >"..tostring(command).."<")
	end
end

function EEAB.OnLoad(this)
	this:RegisterEvent("LOADING_END")
	this:RegisterEvent("LOADING_START")
	this:RegisterEvent("UPDATE_BINDINGS")
	this:RegisterEvent("PLAYER_BAG_CHANGED")
	this:RegisterEvent("PLAYER_INVENTORY_CHANGED")
	this:RegisterEvent("CASTING_START")
	this:RegisterEvent("CASTING_STOP")
	this:RegisterEvent("CASTING_FAILED")
	this:RegisterEvent("UNIT_MAXHEALTH")
	this:RegisterEvent("UNIT_CLASS_CHANGED")

	SaveVariablesPerCharacter("EEAB_Data")

	if not EEAB_Data then
		EEAB_Data = {}
	end

	EEAB.SetHooks()

	MacroPopupIconScrollBar:SetMaxValue(math.ceil(GetNumMacroIcons() / NUM_ICON_ROWS) - NUM_ICONS_PER_ROW)
end

function EEAB.assert(value, msg)
	if not value then
		if EEAB.debugmode then
			EEAB.Log("ERROR:"..tostring(value).." "..tostring(msg))
		end

        error("ExtendedActionBar: "..tostring(msg), 2)
	end
end
