local EEAB = _G.EEAB

function EEAB.ScrollBarValue(this)
	if EEAB_Data and EEAB_Data.Options ~= nil and EEAB.GetClass() ~= nil and EEAB_Data["Options"][EEAB.GetClass()] ~= nil then
		local value = this:GetValue()
		getglobal(this:GetName().."_Value"):SetText(value)

		if this:GetID() == 0 then
			EEAB_Data.Options.updatequota = value
		else
			local val

			if this:GetID() == 2 then
				val = "num"

			elseif this:GetID() == 3 then
				val = "size"
			else
				val = "scale"
			end

			val = val..EEAB.ActiveTab()

			if not EEAB_Data["Options"][EEAB.GetClass()][val] then
				EEAB.UpdateData()
			end

			EEAB_Data["Options"][EEAB.GetClass()][val] = value
		end

		EEAB.Bar_UpdateAll(true)
	end
end

function EEAB.ScrollBar(this, delta)
	if delta > 0 then
		this:SetValue(this:GetValue() - 1)
	else
		this:SetValue(this:GetValue() + 1)
	end
end

function EEAB.KeyCatcher(this, elapsedTime)
	if EEAB.Catchdown then
		EEAB.Catchdown = EEAB.Catchdown - elapsedTime

		if EEAB.Catchdown <= 0 then
			EEAB.Catchdown = nil
			EEAB.HandleHotkeyButton("")
			this:Hide()
		end

		if EEAB.Catchdown then
			getglobal(this:GetName().."_Text"):SetText(EEAB.Trans(30).."\n\n"..(math.floor(EEAB.Catchdown * 1000 + 0.5) / 1000).." s")
		end
	else
		EEAB.Catchdown = 15
	end
end

function EEAB.DropDown_OnLoad(this)
	UIDropDownMenu_SetWidth(this, 100)
	UIDropDownMenu_Initialize(this, EEAB.DropDown_Show)
	UIDropDownMenu_SetText(this, EEAB.Trans(119))
end

function EEAB.DropDown_Show(this)
	local info = {}

	if this:GetID() == 1 then
		if UIDROPDOWNMENU_MENU_LEVEL == 1 then
			UIDropDownMenu_AddButton({
				text = EEAB.Trans(119),
				tooltipText = EEAB.Trans(118),
				isTitle = 1,
				notCheckable = 1,
			})

			UIDropDownMenu_AddButton({
				text = TEXT("OBJ_RESET"),
				notCheckable = 1,
				value = 1,
				hasArrow = 1,
			})

			UIDropDownMenu_AddButton({
				text = EEAB.Trans(117),
				notCheckable = 1,
				value = 2,
				hasArrow = 1,
			})

		elseif UIDROPDOWNMENU_MENU_LEVEL == 2 then
			if UIDROPDOWNMENU_MENU_VALUE == 1 then
				UIDropDownMenu_AddButton({
					text = EEAB.Trans(23),
					tooltipText = EEAB.Trans(8),
					notCheckable = 1,
					func = EEAB.DropDown_Click,
					arg1 = "clearhot",
				}, 2)

				UIDropDownMenu_AddButton({
					text = EEAB.Trans(11),
					tooltipText = EEAB.Trans(10),
					notCheckable = 1,
					func = EEAB.DropDown_Click,
					arg1 = "clearbar",
				}, 2)

				UIDropDownMenu_AddButton({
					text = EEAB.Trans(17),
					tooltipText = EEAB.Trans(19),
					notCheckable = 1,
					func = EEAB.DropDown_Click,
					arg1 = "clearlayout",
				}, 2)

				UIDropDownMenu_AddButton({
					text = EEAB.Trans(121),
					tooltipText = EEAB.Trans(120),
					notCheckable = 1,
					func = EEAB.DropDown_Click,
					arg1 = "clear",
				}, 2)

			elseif UIDROPDOWNMENU_MENU_VALUE == 2 then
				local saves = EEAB.ReturnSavedClasses()

				for i = 1, table.getn(saves) do
					info = {}
					info.notCheckable = 1
					info.text = saves[i]

					if saves[i] == EEAB.GetClass() then
						info.isTitle = 1
					else
						info.func = EEAB.DropDown_Click
						info.arg1 = saves[i]
						info.value = i
						info.hasArrow = 1
					end

					UIDropDownMenu_AddButton(info, 2)
				end
			end

		elseif UIDROPDOWNMENU_MENU_LEVEL == 3 then
			UIDropDownMenu_AddButton({
				text = EEAB.Trans(11),
				tooltipText = EEAB.Trans(10),
				notCheckable = 1,
				func = EEAB.DropDown_Click,
				arg1 = "bar",
			}, 3)

			UIDropDownMenu_AddButton({
				text = EEAB.Trans(17),
				tooltipText = EEAB.Trans(19),
				notCheckable = 1,
				func = EEAB.DropDown_Click,
				arg1 = "layout",
			}, 3)

			UIDropDownMenu_AddButton({
				text = EEAB.Trans(121),
				tooltipText = EEAB.Trans(36),
				notCheckable = 1,
				func = EEAB.DropDown_Click,
				arg1 = "all",
			}, 3)
		end
	else
		EEAB.typ = {"bag","itemshop", "skill", "emote", "SuitSkill", "macro", "HappyPartner", "teleport", "CoolSuit", "equip", "CoolClothBag", "title", "pet", "equipslot"}

		UIDropDownMenu_AddButton({
			text = EEAB.Trans(61),
			isTitle = 1,
		})

		for i = 1, table.getn(EEAB.typ) do
			local category = EEAB.typ[i]

			UIDropDownMenu_AddButton({
				text = EEAB.Trans(61 + (i * 2) - 1),
				func = EEAB.DataManager_SetDropDown,
				arg1 = category,
				tooltipText = EEAB.Trans(61 + (i * 2)),
			})

			EEAB["typ"][category] = i + 1
		end

		EEAB.typ.default = 1
	end
end

function EEAB.ReturnSavedClasses(num)
	local saves = {}

	for name, _ in pairs(EEAB_Data) do
		if name ~= "Bindings" and name ~= "Options" and name ~= "nilnil" and name ~= "version" then
			table.insert(saves, name)
		end
	end

	table.sort(saves)

	if num then
		return saves[num]
	else
		return saves
	end
end

function EEAB.DropDown_Click(this)
	if this.arg1 == "clear" then
		StaticPopupDialogs["EEAB_CLEAR"] = {
			text = EEAB.Trans(33),
			button1 = TEXT("ACCEPT"),
			button2 = TEXT("CANCEL"),

			OnAccept = function(this)
				EEAB_Data[EEAB.GetClass()] = nil

				EEAB.UpdateData()
				EEAB.Bar_UpdateAll(true)

				EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
			end,

			OnCancel = function(this)
			end,

			hideOnEscape = 1,
		}

		StaticPopup_Show("EEAB_CLEAR")

	elseif this.arg1 == "clearhot" then
		StaticPopupDialogs["EEAB_CLEARHOT"] = {
			text = EEAB.Trans(34),
			button1 = TEXT("ACCEPT"),
			button2 = TEXT("CANCEL"),

			OnAccept = function(this)
				EEAB_Data.Bindings = nil

				EEAB.UpdateData()
				EEAB.Bar_UpdateAll(true)

				EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
			end,

			OnCancel = function(this)
			end,

			hideOnEscape = 1,
		}

	elseif this.arg1 == "clearlayout" then
		StaticPopupDialogs["EEAB_CLEARLAYOUT"] = {
			text = EEAB.Trans(18),
			button1 = TEXT("ACCEPT"),
			button2 = TEXT("CANCEL"),

			OnAccept = function(this)
				EEAB_Data[EEAB.GetClass()] = nil

				EEAB.UpdateData()
				EEAB.Bar_UpdateAll(true)

				EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
			end,

			OnCancel = function(this)
			end,

			hideOnEscape = 1,
		}

		StaticPopup_Show("EEAB_CLEARLAYOUT")

	elseif this.arg1 == "clearbar" then
		StaticPopupDialogs["EEAB_CLEARBAR"] = {
			text = EEAB.Trans(12),
			button1 = TEXT("ACCEPT"),
			button2 = TEXT("CANCEL"),

			OnAccept = function(this)
				for name, value in pairs(EEAB_Data["Options"][EEAB.GetClass()]) do
					if string.find(name, "^ExtendedActionBar_") or string.find(name, "^num") or string.find(name, "^size") or string.find(name, "^show") or string.find(name, "^barfree") then
						EEAB_Data["Options"][EEAB.GetClass()][name] = nil
					end
				end

				EEAB.UpdateData()
				EEAB.Bar_UpdateAll(true)

				EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
			end,

			OnCancel = function(this)
			end,

			hideOnEscape = 1,
		}

		StaticPopup_Show("EEAB_CLEARBAR")

	elseif this.arg1 == "all" then
		local arg = EEAB.ReturnSavedClasses(UIDROPDOWNMENU_MENU_VALUE)

		StaticPopupDialogs["EEAB_COPY"] = {
			text = EEAB.Trans(41),
			button1 = TEXT("ACCEPT"),
			button2 = TEXT("CANCEL"),

			OnAccept = function(this)
				EEAB_Data[EEAB.GetClass()] = EEAB_Data[arg]
				EEAB_Data["Options"][EEAB.GetClass()] = EEAB_Data["Options"][arg]

				EEAB.Bar_UpdateAll(true)

				EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
			end,

			OnCancel = function(this)
			end,

			hideOnEscape = 1,
		}

		StaticPopup_Show("EEAB_COPY")

	elseif this.arg1 == "layout" then
		local arg = EEAB.ReturnSavedClasses(UIDROPDOWNMENU_MENU_VALUE)

		StaticPopupDialogs["EEAB_COPY"] = {
			text = EEAB.Trans(123),
			button1 = TEXT("ACCEPT"),
			button2 = TEXT("CANCEL"),

			OnAccept = function(this)
				EEAB_Data[EEAB.GetClass()] = EEAB_Data[arg]

				EEAB.Bar_UpdateAll(true)

				EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
			end,

			OnCancel = function(this)
			end,

			hideOnEscape = 1,
		}

		StaticPopup_Show("EEAB_COPY")

	elseif this.arg1 == "bar" then
		local arg = EEAB.ReturnSavedClasses(UIDROPDOWNMENU_MENU_VALUE)

		StaticPopupDialogs["EEAB_COPY"] = {
			text = EEAB.Trans(122),
			button1 = TEXT("ACCEPT"),
			button2 = TEXT("CANCEL"),

			OnAccept = function(this)
				for name, value in pairs(EEAB_Data["Options"][arg]) do
					if string.find(name, "^ExtendedActionBar_") or string.find(name, "^num") or string.find(name, "^size") or string.find(name, "^show") or string.find(name, "^barfree") then
						EEAB_Data["Options"][EEAB.GetClass()][name] = value
					end
				end

				EEAB.Bar_UpdateAll(true)

				EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
			end,

			OnCancel = function(this)
			end,

			hideOnEscape = 1,
		}

		StaticPopup_Show("EEAB_COPY")
	end
end

function EEAB.OptionsTab(this, swap)
	if swap and getglobal(this:GetName().."Left"):IsVisible() then
		this = getglobal(this:GetParent():GetName().."_Tab"..(math.floor(this:GetID() % 2) + 1))
	end

	PanelTemplates_SelectTab(this)
	PanelTemplates_DeselectTab(getglobal(this:GetParent():GetName().."_Tab"..(math.floor(this:GetID() % 2) + 1)))

	for i = 1, 40 do
		local that = getglobal(this:GetParent():GetName().."_CheckButton"..i)

		if that then
			that:Hide()

			if this:GetID() == 1 and i <= 20 or this:GetID() == 2 and i > 30 then
				that:Show()
			end
		end
	end

	for i = 1, 20 do
		local that = getglobal(this:GetParent():GetName().."_KeyButton"..i)

		if that then
			that:Hide()

			if this:GetID() == 2 then
				that:Show()
			end
		end
	end

	for i = 0, 4 do
		local that = getglobal(this:GetParent():GetName().."_Slider"..i)

		if that then
			that:Hide()

			if (this:GetID() == 1 and i == 0 and not EEAB_Data.Options.slim) or (this:GetID() == 2 and i > 0) then
				that:Show()
			end
		end
	end

end

local DisplayTable = {
	[1] =	{option = "tooltips",	tip =	20,		name =	22,									},
	[2] =	{option = "hotkeys",	tip =	21,		name =	23,									},
	[3] =	{option = "triangel",	tip =	29,		name =	28,									},
	[4] =	{option = "minimap",	tip =	32,		name =	31,									},
	[5] =	{option = "names",		tip =	38,		name =	37,									},
	[6] =	{option = "buffblock",	tip =	43,		name =	42,									},
	[7] =	{option = "slim",		tip =	50,		name =	49,									},
	[8] =	{option = "buffs",		tip =	52,		name =	51,									},
	[9] =	{option = "locked",		tip =	57,		name =	TEXT("GCF_ACTIONBUTTON_LOCKED"),	},
	[10] =	{option = "hideempty",	tip =	58,		name =	TEXT("ACTION_EMPTY_ITEM_HIDDEN"),	},
	[11] =	{option = "bufftime",	tip =	125,	name =	124,								},
	[12] =	{option = "cooldown",	tip =	127,	name =	126,								},
	[13] =	{option = "title",		tip =	130,	name =	129,								},

	[31] =	{option = "showX",		tip =	16,		name =	9,									},
	[32] =	{option = "barfreeX",	tip =	54,		name =	53,									},
}

function EEAB.OptionButtonShow(this)
	if DisplayTable[this:GetID()] then
		local name = EEAB.Trans(DisplayTable[this:GetID()]["name"])

		getglobal(this:GetName().."_Text"):SetText(name)

		local bool = EEAB_Data["Options"][DisplayTable[this:GetID()]["option"]]

		if string.find(DisplayTable[this:GetID()]["option"], "X") then
			bool = EEAB_Data["Options"][EEAB.GetClass()][string.gsub(DisplayTable[this:GetID()]["option"], "X", EEAB.ActiveTab())]
		end

		this:SetChecked(bool)
	else
		this:Hide()
	end
end

function EEAB.OptionButtonClick(this)
	if DisplayTable[this:GetID()] then
		if string.find(DisplayTable[this:GetID()]["option"], "X") then
			local option = string.gsub(DisplayTable[this:GetID()]["option"], "X", EEAB.ActiveTab())

			EEAB_Data["Options"][EEAB.GetClass()][option] = not EEAB_Data["Options"][EEAB.GetClass()][option]
		else
			EEAB_Data["Options"][DisplayTable[this:GetID()]["option"]] = not EEAB_Data["Options"][DisplayTable[this:GetID()]["option"]]
		end
	end

	EEAB.Bar_UpdateAll(true)

	if this:GetID() <= 30 then
		EEAB.OptionsTab(getglobal(this:GetParent():GetName().."_Tab1"))
	end

	EEAB.UpdateData()
end

function EEAB.OptionButtonEnter(this)
	if DisplayTable[this:GetID()] then
		local text = DisplayTable[this:GetID()]["tip"]

		if text then
			EEAB.GameTooltip(this, "ANCHOR_BOTTOMRIGHT", 4, 0, text)
		end
	end
end

function EEAB.OptionKeyClick(this, key)
	EEAB.KeySetBar = EEAB.ActiveTab()
	EEAB.KeySetButton = this:GetID()
	EEAB.KeySetName = this:GetName()

	if key == "RBUTTON" then
		 EEAB.HandleHotkeyButton("")
	else
		ExtendedActionBar_KeyCatcher:Show()
	end
end

function EEAB.OptionKeyEnter(this, num)
	EEAB.GameTooltip(this, "ANCHOR_BOTTOMRIGHT", 4, 0, num or 13)
end

function EEAB.OptionScrollEnter(this)
	local num = 55

	if this:GetID() == 0 then
		num = 47

	elseif this:GetID() == 2 then
		num = 14

	elseif this:GetID() == 3 then
		num = 15
	end

	EEAB.GameTooltip(this, "ANCHOR_BOTTOMRIGHT", 4, 0, num)
end

function EEAB.OptionScrollShow(this)
	local val, text

	if this:GetID() == 2 then
		text = 24
		val = "num"

	elseif this:GetID() == 3 then
		text = 25
		val = "size"

	elseif this:GetID() == 0 then
		text = 48
	else
		text = 56
		val = "scale"
	end

	getglobal(this:GetName().."_Desc"):SetText(EEAB.Trans(text))

	if this:GetID() == 0 then
		this:SetValue(EEAB_Data.Options.updatequota)
	else
		val = val..EEAB.ActiveTab()
		val = EEAB_Data["Options"][EEAB.GetClass()][val]

		this:SetValue(val or 20)
	end

	getglobal(this:GetName().."_Value"):SetText(this:GetValue())

	if this:GetID() == 4 then
		getglobal(this:GetName().."_Low"):SetText(18)
		getglobal(this:GetName().."_High"):SetText(54)
	else
		getglobal(this:GetName().."_Low"):SetText(1)
		getglobal(this:GetName().."_High"):SetText(20)
	end
end

function EEAB.OptionKeyShow(this)
	button = this:GetID()
	bar = EEAB.ActiveTab()
	key = EEAB.GetBindingKey("EXTENDEDACTIONBAR"..EEAB.null(bar).."BUTTON"..EEAB.null(button))

	if key and type(key) ~= "table" then
		this:SetText(key)
	else
		this:SetText(TEXT("KDF_UNDEFINE"))
	end

	local that = getglobal("ExtendedActionBar_"..(bar).."_Button"..this:GetID())
	local text = EEAB.Data(that, "name") or EEAB.Trans("#26# "..this:GetID())

	getglobal(this:GetName().."_Text"):SetText(text)
end

function EEAB.OptionSliderSwapBar(this)
	getglobal(this:GetName().."_Text"):SetText(EEAB.Trans(116).." "..EEAB.ActiveTab())

	EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
end

function EEAB.ActiveTab()
	return ExtendedActionBar_Optionen_Slider1:GetValue()
end

function EEAB.GetBarFree(this)
	while string.find(this:GetName(), "Button") do
		this = this:GetParent()
	end

	return EEAB_Data["Options"][EEAB.GetClass()]["barfree"..this:GetID()] == true
end

function EEAB.GetBarScale(this)
	while string.find(this:GetName(), "Button") do
		this = this:GetParent()
	end

	return EEAB_Data["Options"][EEAB.GetClass()]["scale"..this:GetID()] or 36
end

function EEAB.HandleHotkeyButton(key)
	if EEAB.KeySetName then
		ExtendedActionBar_KeyCatcher:Hide()
		EEAB.Catchdown = nil

		if key == "" then
			key = nil
		end

		EEAB.SetBindingKey("EXTENDEDACTIONBAR"..EEAB.null(EEAB.KeySetBar).."BUTTON"..EEAB.null(EEAB.KeySetButton), key)
	end

	EEAB.OptionsTab(ExtendedActionBar_Optionen_Tab2)
end

function EEAB.GameTooltip(this, anchor, x, y, text, r, g, b)
	if ActionBarTweakerSettings and string.find(this:GetName(), "ExtendedActionBar_%d") then
		GameTooltip:SetOwner(UIParent, ActionBarTweakerSettings.GLOBAL.Main.tooltipAnchor, ActionBarTweakerSettings.GLOBAL.Main.tooltipPosition.x, 		ActionBarTweakerSettings.GLOBAL.Main.tooltipPosition.y)

	elseif pbInfoSettings and pbInfoSettings.STICKYTOOLTIP and string.find(this:GetName(), "ExtendedActionBar_%d") then
		GameTooltip:SetOwner(UIParent, "TOPLEFT", pbInfoSettings["GameTooltipPosition"][1] / GetUIScale(), pbInfoSettings["GameTooltipPosition"][2] / GetUIScale())
	else
		GameTooltip:SetOwner(this, anchor or "ANCHOR_BOTTOMRIGHT", x or 4, y or 0)
	end

	if text then
		GameTooltip:SetText(EEAB.Trans(text), r, g, b)
	end

	GameTooltip:Show() --nessesary?
end
