local EEAB = _G.EEAB

function EEAB.Button_DoItem(this)
	local info = {
		typ		= EEAB.Data(this, "typ"),
		name	= EEAB.Data(this, "name"),
		ID		= EEAB.Data(this, "ID"),
		slot	= EEAB.Data(this, "slot"),
	}

	if info.typ == "bag" or info.typ == "itemshop" then
		if not EEAB_Data.Options.buffblock or not EEAB.CheckBuffs(this) then
			UseItemByName(info.name)
		end

	elseif info.typ == "skill" then
		if not EEAB_Data.Options.buffblock or not EEAB.CheckBuffs(this) then
			UseSkill(info.slot, info.ID)
		end

	elseif info.typ == "emote" then
		DoEmote(info.ID + 1)

	elseif info.typ == "SuitSkill" then
		local that = getglobal(this:GetName().."_Cooldown")

		if not EEAB.CastName and not that.starting and (not EEAB_Data.Options.buffblock or not EEAB.CheckBuffs(this)) then
			local _, _, index = GetSuitSkill_List(info.slot, info.ID)

			EEAB.Mute()

			DragSuitSkill_job(index)

			PickupAction(1)
			UseAction(1)

			EEAB.SuitSkillCooldown(this)

			PickupAction(1)

			EEAB.ClearMouse()
		end

	elseif info.typ == "macro" then
		if not EEAB_Data.Options.buffblock or not EEAB.CheckBuffs(this) then
			EEAB.Mute()

			PickupMacroItem(info.ID)

			PickupAction(1)
			pcall(UseAction, 1)
			PickupAction(1)

			EEAB.ClearMouse()

			EEAB.GetMacroCooldown(this)
		end

	elseif info.typ == "HappyPartner" then
		PartnerFrame_CallPartner(info.slot, info.ID)

	elseif info.typ == "teleport" then
		TeleportBook.select = info.slot
		Do_Teleport(0)

	elseif info.typ == "CoolSuit" then
		CoolSuit_SetPageID(info.slot)

	elseif info.typ == "equip" then
		if not EEAB_Data.Options.buffblock or not EEAB.CheckBuffs(this) then
			UseEquipmentItem(info.ID)
		end

	elseif info.typ == "CoolClothBag" then
		CoolClothBag_Equip(0)
		CoolClothBag_Equip(info.ID)
		CoolSuitOkayButton_OnClick()

	elseif info.typ == "title" then
		EEAB.MacroID = GetCurrentTitle()

		SetTitleRequest(info.slot)

		if EEAB_Data.Options.title then
			local skill = EEAB.GetTitleSkill(info.slot)

			if skill and skill ~= "" then
				EEAB.MacroSkill = skill

				local id

				for i = 1, 20 do
					local name = GetSkillDetail(1, i)

					if name == skill then
						id = i

						break
					end
				end

				for i = 49, 1, -1 do
					if HasMacro(i) then
						local _, name = GetMacroInfo(i)

						if name == "EEAB-Helper" then
							EEAB.Mute()

							PickupMacroItem(i)

							PickupAction(1)
							UseAction(1)

							if id then
								local remaining, duration = GetSkillCooldown(1, id)

								EEAB.CooldownFrame_SetTime(getglobal(this:GetName().."_Cooldown"), duration, remaining)
							end

							PickupAction(1)

							EEAB.ClearMouse()

							break
						end
					end
				end
			end
		end

	elseif info.typ == "pet" then
		SummonPet(info.slot)

	elseif info.typ == "equipslot" then
		SwapEquipmentItem(info.slot)
	end

	EEAB.Button_Update(this)
end
