local EEAB = _G.EEAB

function EEAB.io(msg, c1, c2, c3)
	if not c1 or tonumber(c1) ~= nil and tostring(msg) ~= nil then
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000ExtendedActionBar:|r "..EEAB.Trans(msg), tonumber(c1), tonumber(c2), tonumber(c3))
	end
end

function EEAB.Log(text)
	if EEAB.debugmode then
		DEFAULT_CHAT_FRAME:AddMessage("EEAB DEBUG: "..tostring(text))
	end
end

function EEAB.Trans(te)
	if not EEAB_Transtable then
		EEAB.GenerateTranstable()
	end

	te = te or ""

	if tonumber(te) then
		te = EEAB_Transtable[tonumber(te)]

	elseif EEAB_Transtable[te] then
		te = EEAB_Transtable[te]
	else
		for id, text in pairs(EEAB_Transtable) do
			te = string.gsub(te, "#"..tostring(id).."#", text)

			if not string.find(te, "#") then
				break
			end
		end

		for id, text in ipairs(EEAB_Transtable) do
			te = string.gsub(te, "#"..tostring(id).."#", text)

			if not string.find(te, "#") then
				break
			end
		end
	end

	return te or "Error"
end

function EEAB.GenerateTranstable()
	local phrases = {
		[1]		= "UNKNOWN_COMMAND",
		[2]		= "LOADED",
		[3]		= "LOADING_MESSAGE",
		[4]		= "TYPE_NOT_FOUNT",
		[5]		= "VERSION",
		[6]		= "ADDONMANAGER_DESCRIPTION",
		[7]		= "UPDATE_MESSAGE",
		[8]		= "TOOLTIP_RESET_HOTKEY",
		[9]		= "VISIBLE",
		[10]	= "TOOLTIP_RESET_BARS",
		[11]	= "BARS",
		[12]	= "POPUP_DELETE_BARS",
		[13]	= "HOTKEY_SET_TOOLTIP",
		[14]	= "SCROLLBAR_BUTTONS",
		[15]	= "SCROLLBAR_WIDTH",
		[16]	= "TOOLTIP_HIDE",
		[17]	= "DELETE_LAYOUT",
		[18]	= "POPUP_DELETE_LAYOUT",
		[19]	= "TOOLTIP_DELETE_LAYOUT",
		[20]	= "TOOLTIP_SHOW_TOOLTIPS",
		[21]	= "TOOLTIP_HOTKEYS",
		[22]	= "TOOLTIPS",
		[23]	= "HOTKEYS",
		[24]	= "FIELDS",
		[25]	= "WIDTH",
		[26]	= "BUTTON",
		[27]	= "ERROR_CLOSE_CONFIGUARION",
		[28]	= "ANCHOR",
		[29]	= "TOOLTIP_ANCHOR",
		[30]	= "SET_HOTKEY",
		[31]	= "MINIMAP_BUTTON",
		[32]	= "TOOLTIP_MINIMAP_BUTTON",
		[33]	= "POPUP_DELETE_SETTINGS",
		[34]	= "POPUP_DELETE_HOTKEY",
		[35]	= "TOOLTIP_DELETE_SETTINGS",
		[36]	= "TOOLTIP_APPLY_CLASS",
		[37]	= "HIDE_NAMES",
		[38]	= "TOOLTIP_HIDE_NAMES",
		[39]	= "DELETE_HOTKEYS",
		[40]	= "TOOLTIP_DELETE_HOTKEYS",
		[41]	= "POPUP_APPLY_CLASS",
		[42]	= "BUFF_BLOCK",
		[43]	= "TOOLTIP_BUFF_BLOCK",
		[44]	= "ERROR_MACRO",
		[45]	= "MESSAGE_ORIGINAL_ACTION_BAR",
		[46]	= "ERROR_ICON",
		[47]	= "TOOLTIP_SCROLLBAR_UPDATE_QUOTA",
		[48]	= "UPDATE_QUOTA",
		[49]	= "SLIM",
		[50]	= "TOOLTIP_SLIM",
		[51]	= "BUFFINDICATOR",
		[52]	= "TOOLTIP_BUFFINDICATOR",
		[53]	= "BARFREE",
		[54]	= "TOOLTIP_BARFREE",
		[55]	= "TOOLTIP_SCROLLBAR_SCALE",
		[56]	= "SCALING",
		[57]	= "TOOLTIP_LOCK_BUTTONS",
		[58]	= "TOOLTIP_HIDE_EMPTY",
		[59]	= "DATA_MANAGER",
		[60]	= "BAR",
		[61]	= "CATEGORY",
		[62]	= "BACKPACK",
		[63]	= "TOOLTIP_BACKBAG",
		[64]	= "ITEMSHOP",
		[65]	= "TOOLTIP_ITEMSHOP",
		[66]	= "SKILLS",
		[67]	= "TOOLTIP_SKILLS",
		[68]	= "EMOTE",
		[69]	= "TOOLTIP_EMOTE",
		[70]	= "SETSKILL",
		[71]	= "TOOLTIP_SETSKILL",
		[72]	= "MACRO",
		[73]	= "TOOLTIP_MACRO",
		[74]	= "PETBAG",
		[75]	= "TOOLTIP_PETBAG",
		[76]	= "TELEPORT",
		[77]	= "TOOLTIP_TELEPORT",
		[78]	= "WARDROBE_SET",
		[79]	= "TOOLTIP_WARDROBE_SET",
		[80]	= "EQUIPMENT",
		[81]	= "TOOLTIP_EQUIPMENT",
		[82]	= "WARDROBE_SINGLE",
		[83]	= "TOOLTIP_WARDROBE_SINGLE",
		[84]	= "TITLE",
		[85]	= "TOOLTIP_TITLE",
		[86]	= "ACTIVE_PET",
		[87]	= "TOOLTIP_ACTIVE_PET",
		[88]	= "EQUIPMENT_SET",
		[89]	= "TOOLTIP_EQUIPMENT_SET",
		[90]	= "DATA_MANAGER_ABORT",
		[91]	= "DATA_MANAGER_CHANGED",
		[92]	= "DATA_MANAGER_DONE",
		[93]	= "SPECIFY_NAME",
		[94]	= "SPECIFY_NUMBER_BAR",
		[95]	= "SPECIFY_NUMBER_BUTTON",
		[96]	= "SPECIFY_TAB_SKILL",
		[97]	= "SPECIFY_NUMBER_SKILL",
		[98]	= "SPECIFY_EMOTE",
		[99]	= "SPECIFY_CLASS_SETSKILL",
		[100]	= "SPECIFY_NUMBER_SETSKILL",
		[101]	= "SPECIFY_NAME_OR",
		[102]	= "SPECIFY_MACRO",
		[103]	= "SPECIFY_TAB_PETBAG",
		[104]	= "SPECIFY_NUMBER_PETBAG",
		[105]	= "SPECIFY_TELEPORT",
		[106]	= "SPECIFY_CLOTHING",
		[107]	= "SPECIFY_EQUIPMENT_SLOT",
		[108]	= "SPECIFY_NUMBER_WARDROBE",
		[109]	= "TOOLTIP_TECHNICAL_DATA",
		[110]	= "SPECIFY_NUMBER_PET",
		[111]	= "SPECIFY_EQUIPMENT",
		[112]	= "SPECIFY_TITLE",
		[113]	= "GENERAL_OPTIONS",
		[114]	= "BAR_OPTIONS",
		[115]	= "TOOLTIP_SCROLLBAR_BAR",
		[116]	= "HEADING_SCROLLBAR_BAR",
		[117]	= "TRANSFER",
		[118]	= "TOOLTIP_TRANSFER",
		[119]	= "COPY_DELETE",
		[120]	= "TOOLTIP_RESET_ALL",
		[121]	= "ALL",
		[122]	= "POPUP_APPLY_LAYOUT",
		[123]	= "POPUP_APPLY_BARS",
		[124]	= "BUFFTIME",
		[125]	= "TOOLTIP_BUFFTIME",
		[126]	= "COOLDOWN_ACCURACY",
		[127]	= "TOOLTIP_COOLDOWN_ACCURACY",
		[128]	= "TOOLTIP_TECHNICAL_ICON",
		[129]	= "USE_TITLE",
		[130]	= "TOOLTIP_USE_TITLE",
		--##new phrases not saved with the loca-app on curseforge:
		-- non
	}

	EEAB_Transtable = {}

	for number, value in ipairs(phrases) do
		EEAB_Transtable[number] = EEAB_Transtext[value] or "Missing Translation #"..tostring(number)
		EEAB_Transtable[value] = EEAB_Transtext[value] or "Missing Translation #"..tostring(value)
	end
end
