local EEAB = _G.EEAB

EEAB.OnUpdate_coutner = 0

function EEAB.OnUpdate(this, elapsedTime)
	if not EEAB_Data.Options.slim or EEAB.OnUpdate_coutner >= 0.1 then
		if EEAB_AddUpdate then
			local quota = EEAB_Data.Options.updatequota or 1

			if EEAB_Data.Options.slim then
				quota = 1
			end

			for i = 1, quota do
				if next(EEAB_AddUpdate) then
					local name = next(EEAB_AddUpdate)

					EEAB.Button_Update(name)

					EEAB_AddUpdate[name] = nil
				else
					break
				end
			end
		end

		if EEAB.Audio then
			if EEAB.AudioCount then
				if EEAB.AudioCount <= 0 then
					InterfaceSFXVolumeSlider_SetValue(EEAB.Audio)
					EEAB.Audio = nil
					EEAB.AudioCount = nil
				else
					EEAB.AudioCount = EEAB.AudioCount - elapsedTime
				end
			else
				EEAB.AudioCount = 0.4
			end
		end

		if EEAB.Spellcache then
			for name, info in pairs(EEAB.Spellcache) do
				if not info.tag then
					if info.delay <= 0 then
						EEAB.CooldownFrame_SetTime(getglobal(info.frame.."_Cooldown"), info.cooldown, info.remaining)

						EEAB.Button_Update(getglobal(info.frame))

						EEAB["Spellcache"][name] = nil
					else
						EEAB["Spellcache"][name]["delay"] = EEAB["Spellcache"][name]["delay"] - elapsedTime
					end
				end
			end
		end

		EEAB.OnUpdate_coutner = 0
	else
		EEAB.OnUpdate_coutner = EEAB.OnUpdate_coutner + elapsedTime
	end
end

function EEAB.OnEvent(this, event, arg1, arg2, arg3, arg4)
	if event == "UPDATE_BINDINGS" then
		EEAB_DefaultBindings = nil

		EEAB.Bar_UpdateAll(true)

	elseif event == "CASTING_START" then
		EEAB.CastName = arg1

		if EEAB["Spellcache"] and EEAB["Spellcache"][EEAB.CastName] then
			EEAB["Spellcache"][EEAB.CastName]["tag"] = true
		end

	elseif event == "CASTING_STOP" then
		if EEAB.Spellcache and EEAB["Spellcache"][EEAB.CastName] then
			local info = EEAB["Spellcache"][EEAB.CastName]

			EEAB["Spellcache"][EEAB.CastName] = nil

			EEAB.CooldownFrame_SetTime(getglobal(info.frame.."_Cooldown"), info.cooldown, info.remaining)
		end

		EEAB.CastName = nil

	elseif event == "CASTING_FAILED" then
		EEAB.CastName = nil

	elseif event == "UNIT_MAXHEALTH" and arg1 == "player" then
		EEAB.Bar_UpdateAll(true)

	elseif event == "LOADING_START" then
		ExtendedActionBar_EventFrame:Hide()

	elseif event == "LOADING_END" then
		EEAB.IntData()

		ExtendedActionBar_EventFrame:Show()

	elseif event == "UNIT_CLASS_CHANGED" then
		EEAB.UpdateData()

		EEAB.Bar_UpdateAll(true)
	end
end

function EEAB.AddUpdate(this)
	if EEAB_AddUpdate then
		EEAB_AddUpdate[this] = true
	end
end

function EEAB.Register(this)
	typ = EEAB.Data(this, "typ")

	if typ == "bag" or typ == "itemshop" then
		this:RegisterEvent("PLAYER_BAG_CHANGED")
		this:RegisterEvent("PLAYER_INVENTORY_CHANGED")

	elseif typ == "skill" then
		this:RegisterEvent("SKILL_UPDATE_COOLDOWN")

	elseif typ == "CoolSuit" then
		this:RegisterEvent("PLAYER_COOL_SUIT_CHANGED")

	elseif typ == "macro" then
		this:RegisterEvent("MACROFRAME_UPDATE")

	elseif typ == "equip" then
		this:RegisterEvent("SWAP_EQUIPMENT_SUCCESS")
		this:RegisterEvent("PLAYER_EQUIPMENT_UPDATE")
	end
end

function EEAB.Unregister(this)
	this:UnregisterEvent("PLAYER_BAG_CHANGED")
	this:UnregisterEvent("PLAYER_INVENTORY_CHANGED")
	this:UnregisterEvent("PLAYER_COOL_SUIT_CHANGED")
	this:UnregisterEvent("SKILL_UPDATE_COOLDOWN")
	this:UnregisterEvent("MACROFRAME_UPDATE")
	this:UnregisterEvent("SWAP_EQUIPMENT_SUCCESS")
	this:UnregisterEvent("PLAYER_EQUIPMENT_UPDATE")
end

function EEAB.ClearMouse()
	if CursorHasItem() then
		local typ = CursorItemType()

		if typ == "bag" or typ == "itemshop" then
			PickupBagItem(GetCursorItemInfo())
		else
			OnDrag_SkillButton(getglobal("UI_SkillBook_SkillButton_1ItemButton"), 1)
		end
	end
end

function EEAB.SetItemButtonCount(button, count)
	local count = count or 0

	if count > 1 then
		if count > 999 then
			count = "*"
		end

		getglobal(button:GetName().."_Count"):SetText(count)
		getglobal(button:GetName().."_Count"):Show()
	else
		getglobal(button:GetName().."_Count"):Hide()
	end
end

function EEAB.SetItemButtonLuminance(button, luminance, typ)
	local icon = getglobal(button:GetName().."_Icon")

	if luminance and (typ  == "bag" or typ == "itemshop") then
		icon:SetLuminance(true)

	else
		icon:SetLuminance(false)
	end
end

function EEAB.Count(this, typ)
	local count = 0
	local name = EEAB.Data(this, "name")

	if typ == "bag" then
		for i = 1, 360 do
			local _, _, name2, count2 = GetBagItemInfo(i)

			if name == name2 then
				count = count + count2

				EEAB.Data(this, "slot", i)
				EEAB.Data(this, "ID", GetBagItemInfo(i))
			end
		end
	else
		for i = 1, 50 do
			local _, name2, count2 = GetGoodsItemInfo(i)

			if name == name2 then
				count = count + count2

				EEAB.Data(this, "ID", i)
			end
		end
	end

	EEAB.Data(this, "count", count)

	return count
end

function EEAB.Data(this, var, val)
	if EEAB_Data[EEAB.GetClass()] and EEAB_Data[EEAB.GetClass()][this:GetParent():GetID()] and EEAB_Data[EEAB.GetClass()][this:GetParent():GetID()][this:GetID()] then
		if val then
			EEAB_Data[EEAB.GetClass()][this:GetParent():GetID()][this:GetID()][var] = val

		elseif type(var) == "table" then
			EEAB_Data[EEAB.GetClass()][this:GetParent():GetID()][this:GetID()] = var
		else
			return EEAB_Data[EEAB.GetClass()][this:GetParent():GetID()][this:GetID()][var]
		end
	else
		return 0
	end
end

function EEAB.IntData()
	if not EEAB_Data then
		EEAB_Data = {}
	end

	if not EEAB.Spellcache then
		EEAB.Spellcache = {}
	end

	if not EEAB_AddUpdate then
		EEAB_AddUpdate = {}
	end

	if not EEAB.LastCooldown then
		EEAB.LastCooldown = {}
	end

	if not EEAB_Data.version or EEAB_Data.version ~= EEAB.version then
		EEAB_Data.version = EEAB.version

		EEAB.io(7)
		ExtendedActionBar_Optionen:Show()

		EEAB.UpdateData()
	end
end

function EEAB.GetClass()
	local m, s = UnitClass("player")

	return tostring(m)..tostring(s)
end

function EEAB.null(i)
	if i then
		if i < 10 then
			i = "000"..tostring(i)
		elseif i < 100 then
			i = "00"..tostring(i)
		elseif i < 1000 then
			i = "0"..tostring(i)
		end
	end

	return i or ""
end

function EEAB.Mute()
	if InterfaceSFXVolumeSlider_GetValue() ~= 0 then
		EEAB.Audio = InterfaceSFXVolumeSlider_GetValue()
		InterfaceSFXVolumeSlider_SetValue(0)
	end
end

function EEAB.Rel(value, xory)
	local scale = UIParent:GetRealScale()

	if xory then
		xory = GetScreenWidth() / scale
	else
		xory = GetScreenHeight() / scale
	end

	value = (value or 100) / xory * 100 / scale

	return value
end

function EEAB.Abs(value, xory)
	local scale = UIParent:GetRealScale()

	if xory then
		xory = GetScreenWidth() / scale
	else
		xory = GetScreenHeight() / scale
	end

	value = (value or 100) * xory / 100 * scale

--	if value < 0 then
--		value = 5

--	elseif value > xory then
--		value = xory - 5
--	end

	return value
end

function EEAB.UpdateData()
	if not EEAB_Data[EEAB.GetClass()] then
		EEAB_Data[EEAB.GetClass()] = {}
	end

	for j = 1, EEAB.Bar_GetNum() do
		if not EEAB_Data[EEAB.GetClass()][j] then
			EEAB_Data[EEAB.GetClass()][j] = {}

			for i = 1, 20 do
				EEAB_Data[EEAB.GetClass()][j][i] = {}
			end
		end
	end

	if not EEAB_Data.Bindings then
		EEAB_Data.Bindings = {}
	end

	for j = 1, EEAB.Bar_GetNum() do
		if not EEAB_Data["Bindings"][j] then
			EEAB_Data["Bindings"][j] = {}

			for i = 1, 20 do
				EEAB_Data["Bindings"][j][i] = {}
			end
		end
	end

	if not EEAB_Data.Options then
		EEAB_Data.Options = {}
	end

	local defaults = {
		tooltips	= true,
		hotkeys		= true,
		triangel	= true,
		minimap		= true,
		names		= false,
		buffblock	= false,
		slim		= false,
		buffs		= true,
		locked		= GetActionBarLocked(),
		hideempty	= GetActionBarHideEmpty(),
		bufftime	= false,
		cooldown	= true,
		title		= true,
	}

	for name, value in pairs(defaults) do
		if EEAB_Data.Options[name] == nil then
			EEAB_Data.Options[name] = value
		end
	end

	for i = 49, 1, -1 do
		if HasMacro(i) then
			local _, name = GetMacroInfo(i)

			if name == "EEAB-Helper" then
				if not EEAB_Data.Options.title then
					EditMacro(i, nil, nil, nil)
				end

				break
			end
		else
			if EEAB_Data.Options.title then
				EditMacro(i, "EEAB-Helper", 1, "/wait 1\n/eeab helper1\n/wait 1\n/eeab helper2")
			end

			break
		end
	end

	if not EEAB_Data.Options.updatequota then
		EEAB_Data.Options.updatequota = 5
	end

	if not EEAB_Data["Options"][EEAB.GetClass()] or EEAB_Data["Options"][EEAB.GetClass()]["size1"] == nil then
		EEAB_Data["Options"][EEAB.GetClass()] = {
			show1 = true,
			num1  = 10,
			size1 = 20,

			show2 = true,
			num2  = 10,
			size2 = 20,

			show3 = false,
			num3  = 10,
			size3 = 1,

			show4 = false,
			num4  = 10,
			size4 = 1,
		}
	end


	local scale, bool = 36, false

	if EEAB_Data.Options.scale then
		scale = EEAB_Data.Options.scale

		EEAB_Data.Options.scale = nil
	end

	if EEAB_Data.Options.barfree ~= nil then
		bool = EEAB_Data.Options.barfree

		EEAB_Data.Options.barfree = nil
	end

	for i = 1, EEAB.Bar_GetNum() do
		if not EEAB_Data["Options"][EEAB.GetClass()]["scale"..i] then
			EEAB_Data["Options"][EEAB.GetClass()]["scale"..i] = scale
			EEAB_Data["Options"][EEAB.GetClass()]["barfree"..i] = bool
		end
	end

	if EEAB_Data["Options"][EEAB.GetClass()] and EEAB_Data["Options"][EEAB.GetClass()]["pos1x"] then
		for i = 1, 4 do
			local x = EEAB_Data["Options"][EEAB.GetClass()]["pos"..i.."x"]
			local y = EEAB_Data["Options"][EEAB.GetClass()]["pos"..i.."y"]

			if x then
				EEAB_Data["Options"][EEAB.GetClass()]["ExtendedActionBar_"..i.."_Button1"] = {
					"TOPLEFT",
					"TOPLEFT",
					"UIParent",
					EEAB.Rel(x, true),
					EEAB.Rel(y, false),
				}

				EEAB_Data["Options"][EEAB.GetClass()]["pos"..i.."x"] = nil
				EEAB_Data["Options"][EEAB.GetClass()]["pos"..i.."y"] = nil
			end
		end
	end

	if not EEAB_Data.Bindings[5] then
		for j = 5, EEAB.Bar_GetNum() do
			EEAB_Data["Bindings"][j] = {}
			EEAB_Data[EEAB.GetClass()][j] = {}

			for i = 1, 20 do
				EEAB_Data["Bindings"][j][i] = {}
				EEAB_Data[EEAB.GetClass()][j][i] = {}
			end

			EEAB_Data["Options"][EEAB.GetClass()]["show"..j] = false
			EEAB_Data["Options"][EEAB.GetClass()]["scale"..j] = 36
			EEAB_Data["Options"][EEAB.GetClass()]["barfree"..j] = true
		end

		EEAB_Data["Options"][EEAB.GetClass()]["num5"] = 10
		EEAB_Data["Options"][EEAB.GetClass()]["size5"] = 20

		EEAB_Data["Options"][EEAB.GetClass()]["num6"] = 20
		EEAB_Data["Options"][EEAB.GetClass()]["size6"] = 10
	end
end

function EEAB.ChooseAnchor(x, y, actualanchor)
	local scale, anchor = UIParent:GetRealScale()
	local height, width = GetScreenHeight() / scale, GetScreenWidth() / scale

	--x, y = EEAB.CalculateAnchor(x, y, actualanchor, "TOPLEFT")

	if y < (height / 2) then
		anchor = "TOP"
	else
		anchor = "BOTTOM"
	end

	if x < (width / 2) then
		anchor = anchor.."LEFT"
	else
		anchor = anchor.."RIGHT"
	end

	--x, y = EEAB.CalculateAnchor(x, y, "TOPLEFT", actualanchor)

	anchor = anchor or actualanchor

	x, y = EEAB.CalculateAnchor(x, y, actualanchor, anchor)

	return x, y, anchor
end

function EEAB.CalculateAnchor(x, y, actualanchor, newanchor)
	newanchor = newanchor or "TOPLEFT"
	actualanchor = actualanchor or "TOPLEFT"

	local scale = UIParent:GetRealScale()
	local height, width = GetScreenHeight() / scale, GetScreenWidth() / scale

	if string.find(actualanchor, "TOP") and string.find(newanchor, "BOTTOM") then
		y = y - height

	elseif string.find(actualanchor, "BOTTOM") and string.find(newanchor, "TOP") then
		y = height + y
	end

	if string.find(actualanchor, "LEFT") and string.find(newanchor, "RIGHT") then
		x = x - width

	elseif string.find(actualanchor, "RIGHT") and string.find(newanchor, "LEFT") then
		x = width + x
	end

	return x, y
end
