local EEAB = _G.EEAB

function EEAB.Button_SetItem(this)
	local typ = CursorItemType()

	local info = {
		typ		= typ,
		name	= nil,
		texture	= nil,
		count	= nil,
		ID		= nil,
		slot	= nil,
		indent	= nil,
	}

	if typ == "bag" then
		local a = GetCursorItemInfo()

		for i = 1, 360 do
			local slot = GetBagItemInfo(i)

			if slot and slot == a then
				info.slot = i
				info.ID, info.texture, info.name, info.count = GetBagItemInfo(info.slot)

				break
			end
		end

		if not info.texture then
			info.typ = "itemshop"
			info.slot = a
			info.ID = a
			info.texture, info.name, info.count = GetGoodsItemInfo(info.slot)
		end

	elseif typ == "skill" then
		info.slot, info.ID = EEAB_DragSkillButton_page, EEAB_DragSkillButton_number
		info.name, _, info.texture = GetSkillDetail(info.slot, info.ID)

	elseif typ == "emote" then
		info.ID = GetCursorItemInfo() - 2
		_, info.name, _, info.texture = GetEmoteInfo(info.ID)

	elseif typ == "SuitSkill" then
		info.slot, info.ID = EEAB_SkillSuitItemTemplate_Button_OnDragStart_page, EEAB_SkillSuitItemTemplate_Button_OnDragStart_number
		info.name, info.texture, info.count = GetSuitSkill_List(info.slot, info.ID)

	elseif typ == "SkillPlate" then
		info.name, info.texture = SkillPlateUpdate(PLATECLICKINDEX - 1)

		for i = 0, 11 do
			for j = 0, 10 do
				local a, b, c = GetSuitSkill_List(i, j)

				if a == info.name then
					info.slot, info.ID, info.count = i, j, c
					info.typ = "SuitSkill"

					break
				end
			end

			if a and a == info.name then
				break
			end
		end

	elseif typ == "macro" then
		info.ID = GetCursorItemInfo()
		info.count, info.name = GetMacroInfo(info.ID)

		if not info.count then
			EEAB.io(44)

			info = {}
		else
			info.texture = GetMacroIconInfo(info.count)
		end

	elseif typ == "HappyPartner" then
		info.slot, info.ID, info.indent = EEAB_PartnerListButton_OnDrag_page, EEAB_PartnerListButton_OnDrag_number, EEAB_PartnerListButton_OnDrag_indent
		info.texture, _, info.name = PartnerFrame_GetPartnerInfo(info.slot, info.ID)

	elseif typ == "teleport" then
		info.slot = TeleportBook.select
		_, info.name, _, _, _, _, _, info.texture = TB_GetTeleportInfo(info.slot)

	elseif typ == "CoolSuit" then
		info.slot = EEAB_CoolSuitButton_Pickup

		if info.slot then
			info.name = string.gsub(TEXT("SYS_COOLSUIT_PAGE_TIPS"), "<number>", tonumber(info.slot))

			_, info.texture = CoolSuit_GetItemInfo(info.slot, 3)

			if not info.texture then
				for i = 1, 9 do
					_, info.texture = CoolSuit_GetItemInfo(info.slot, i)

					if info.texture then
						break
					end
				end
			end

			if not info.texture then
				info.texture = CoolSuit_GetPageTexture(info.slot)
			end
		else
			return
		end

	elseif typ == "equip" then
		info.ID = GetCursorItemInfo() - 1
		info.texture = GetInventoryItemTexture("player", info.ID)

		local frames = {"Ring0Slot", "Ring1Slot", "Earring0Slot", "Earring1Slot", "NecklaceSlot", "Talisman0Slot", "Talisman1Slot", "Talisman2Slot", "HeadSlot", "ChestSlot", "WaistSlot", "LegsSlot", "MainHandSlot", "RangedSlot", "ShoulderSlot", "HandsSlot", "FeetSlot", "BackSlot", "SecondaryHandSlot", "AdornmentSlot"}

		for _, name in pairs(frames) do
			if GetInventorySlotInfo(name) == info.ID then
				info.name = name

				break
			end
		end

	elseif typ == "CoolClothBag" then
		info.ID = EEAB_CoolClothBagItemButton_OnClick_ID
		info.name, info.texture = CoolClothBag_GetItem(info.ID)
		info.name = TEXT("Sys"..info.name.."_name")

	elseif typ == "action" then
		info.slot = GetCursorItemInfo() - 1

		local bool = false

		info.name = TEXT("Sys"..info.slot.."_name")

		local try = {}
		try.typ = "bag"

		for i = 1, 360 do
			local slot = GetBagItemInfo(i)

			if slot then
				try.slot = i
				try.ID, try.texture, try.name, try.count = GetBagItemInfo(try.slot)

				if try.name == info.name then
					bool = true

					break
				end
			end
		end

		if not bool then
			try = {}
			try.typ = "itemshop"

			for i = 1, 50 do
				try.slot = i
				try.ID = i
				try.texture, try.name, try.count = GetGoodsItemInfo(i)

				if try.name == info.name then
					bool = true

					break
				end
			end
		end

		if not bool then
			try = {}
			try.typ = "skill"

			for i = 1, 4 do
				for j = 1, 40 do
					try.slot, try.ID = i, j

					try.name, _, try.texture = GetSkillDetail(i, j)

					if try.name == info.name then
						bool = true

						break
					end
				end

				if bool then
					break
				end
			end
		end

		if not bool then
			try = {}
			try.typ = "SuitSkill"

			for i = 0, 11 do
				for j = 0, 10 do
					try.slot, try.ID = i, j
					try.name, try.texture, try.count = GetSuitSkill_List(i, j)

					if try.name == info.name then
						bool = true

						break
					end
				end

				if bool then
					break
				end
			end
		end

		if not bool then
			try = {}
			try.typ = "macro"

			info.slot = info.slot + 1
			try.ID = info.slot

			try.count, try.name = GetMacroInfo(try.ID)

			EEAB.io(45)

			if not try.count then
				EEAB.io(44)

				try = {}
			else
				try.texture = GetMacroIconInfo(try.count)

				bool = true
			end
		end

		if bool then
			info = try
		else
			EEAB.io(46)
			EEAB.io("ID: "..tostring(info.slot))

			info = {}
		end

	elseif typ then
		EEAB.io("#4# "..tostring(CursorItemType()))

		info.typ = nil
	end

	EEAB.ClearMouse()

	EEAB.UseMouse = nil

	if EEAB.HasAction(this) then
		EEAB.Button_MoveItem(this, true)
	end

	getglobal(this:GetName().."_Cooldown").starting = nil
	getglobal(this:GetName().."_Cooldown"):Hide()

	EEAB.Data(this, info)
	EEAB.Register(this)
	EEAB.Button_Update(this)
end
