local EEAB = _G.EEAB

function EEAB.Button_Tooltip(this)
	if EEAB_Data.Options.tooltips then
		EEAB.GameTooltip(this, "ANCHOR_TOPLEFT", -5, 0)

		local info = {
			typ		= EEAB.Data(this, "typ"),
			name	= EEAB.Data(this, "name"),
			ID		= EEAB.Data(this, "ID"),
			slot	= EEAB.Data(this, "slot"),
			count	= EEAB.Count(this, EEAB.Data(this, "typ")),
		}

		if info.typ == "SuitSkill" then
			local _, _, index = GetSuitSkill_List(info.slot, info.ID)

			GameTooltip:SetSuitSkillListItem(index)

		elseif info.typ == "bag" then
			if info.count == 0 then
				GameTooltip:SetText(info.name)
			else
				GameTooltip:SetBagItem(GetBagItemInfo(info.slot))
			end

		elseif info.typ == "itemshop" then
			if info.count == 0 then
				GameTooltip:SetText(info.name)
			else
				GameTooltip:SetBagItem(info.ID)
			end

		elseif info.typ == "emote" then
			local _ , name, token = GetEmoteInfo(info.ID)

			GameTooltip:SetText(name)
			GameTooltip:AddLine("/"..token)

		elseif info.typ == "HappyPartner" then
			local indent = EEAB.Data(this, "indent")

			if indent and tonumber(indent) then
				GameTooltip:SetPartnerItem(indent)
			else
				GameTooltip:SetText(info.name)
			end

		elseif info.typ == "macro" then
			GameTooltip:SetText(info.name)

		elseif info.typ == "CoolSuit" then
			GameTooltip:SetText(info.name)

		elseif info.typ == "equip" then
			GameTooltip:SetInventoryItem("player", info.ID)

		elseif info.typ == "skill" then
			if GetSkillDetail(info.slot, info.ID) then
				GameTooltip:SetSkillItem(info.slot, info.ID)
			else
				GameTooltip:SetText(info.name)
			end

		elseif info.typ == "CoolClothBag" then
			local _, _, _, _, slot = CoolClothBag_GetItem(info.ID)

			GameTooltip:SetHyperLink(slot)

		elseif info.typ == "title" then
			GameTooltip:SetTitle(info.slot)

		elseif info.typ == "pet" then
			GameTooltip:SetText(info.name)

		elseif info.typ == "equipslot" then
			GameTooltip:SetText(info.name)
		else
			GameTooltip:Hide()
		end
	end
end
