local EEAB = _G.EEAB

function EEAB.SetHooks()
	EEAB.Hooked_DragSkillButton = DragSkillButton
	DragSkillButton = EEAB.DragSkillButton

	EEAB.Hooked_SkillSuitItemTemplate_Button_OnDragStart = SkillSuitItemTemplate_Button_OnDragStart
	SkillSuitItemTemplate_Button_OnDragStart = EEAB.SkillSuitItemTemplate_Button_OnDragStart

	EEAB.Hooked_PartnerListButton_OnDrag = PartnerListButton_OnDrag
	PartnerListButton_OnDrag = EEAB.PartnerListButton_OnDrag

	EEAB.Hooked_ImplementActionFrame_OnShow = ImplementActionFrame_OnShow
	ImplementActionFrame_OnShow = EEAB.ImplementActionFrame_OnShow

	EEAB.Hooked_ImplementActionFrame_OnHide = ImplementActionFrame_OnHide
	ImplementActionFrame_OnHide = EEAB.ImplementActionFrame_OnHide

	EEAB.Hooked_ChatFrame_OnHyperlinkClick = ChatFrame_OnHyperlinkClick
	ChatFrame_OnHyperlinkClick = EEAB.ChatFrame_OnHyperlinkClick

	EEAB.Hooked_MacroFrame_OnShow = MacroFrame_OnShow
	MacroFrame_OnShow = EEAB.MacroFrame_OnShow

	if EAB_KeyDown then
		EEAB.Hooked_EAB_KeyDown = EAB_KeyDown
		EAB_KeyDown = EEAB.EAB_KeyDown

		EEAB.Hooked_EAB_KeyUp = EAB_KeyUp
		EAB_KeyUp = EEAB.EAB_KeyUp
	end

	EEAB.Hooked_StaticPopup_Show = StaticPopup_Show
	StaticPopup_Show = EEAB.StaticPopup_Show

	EEAB.Hooked_CoolSuitButton_Pickup = CoolSuitButton_Pickup
	CoolSuitButton_Pickup = EEAB.CoolSuitButton_Pickup

	EEAB.Hooked_CoolClothBagItemButton_OnClick = CoolClothBagItemButton_OnClick
	CoolClothBagItemButton_OnClick = EEAB.CoolClothBagItemButton_OnClick

	EEAB.Hooked_CooldownFrame_SetTime = CooldownFrame_SetTime
	CooldownFrame_SetTime = EEAB.CooldownFrame_SetTime_Hook
end

function EEAB.ImplementActionFrame_OnShow(this)
	EEAB.Hooked_ImplementActionFrame_OnShow(this)

	ExtendedActionBar_KeyFrame:Hide()
	EEAB.Bar_UpdateAll()
end

function EEAB.ImplementActionFrame_OnHide(this)
	EEAB.Hooked_ImplementActionFrame_OnHide(this)

	ExtendedActionBar_KeyFrame:Show()
	EEAB.Bar_UpdateAll()
end

function EEAB.EAB_KeyDown(key)
	EEAB.Hooked_EAB_KeyDown(key)

	EEAB.Key(key, false)
end

function EEAB.EAB_KeyUp(key)
	EEAB.Hooked_EAB_KeyUp(key)

	EEAB.Key(key, true)
end

function EEAB.DragSkillButton(page, number)
	EEAB_DragSkillButton_page = page
	EEAB_DragSkillButton_number = number

	EEAB.Hooked_DragSkillButton(page, number)
end

function EEAB.SkillSuitItemTemplate_Button_OnDragStart(this)
	EEAB_SkillSuitItemTemplate_Button_OnDragStart_page = this:GetParent():GetParent():GetParent():GetID()
	EEAB_SkillSuitItemTemplate_Button_OnDragStart_number = this:GetParent():GetID() - 1

	EEAB.Hooked_SkillSuitItemTemplate_Button_OnDragStart(this)
end

function EEAB.PartnerListButton_OnDrag(this)
	EEAB_PartnerListButton_OnDrag_page = this.info.mode
	EEAB_PartnerListButton_OnDrag_number = this.info.pos
	EEAB_PartnerListButton_OnDrag_indent = this:GetID()

	EEAB.Hooked_PartnerListButton_OnDrag(this)
end

function EEAB.ChatFrame_OnHyperlinkClick(this, link, key)
	ExtendedActionBar_KeyFrame:ClearFocus()

	EEAB.Hooked_ChatFrame_OnHyperlinkClick(this, link, key)
end

function EEAB.MacroFrame_OnShow(this)
	EEAB.Hooked_MacroFrame_OnShow(this)

	EEAB.Mute()

	for i = 1, 49 do
		if HasMacro(i) then
			PickupMacroItem(i)
			PickupMacroItem(GetCursorItemInfo())
		end
	end
end

function EEAB.StaticPopup_Show(which, text_arg1, text_arg2, data)
	if (which == "DELETE_ITEM" or which == "DELETE_QUESTITEM") and EEAB.UseMouse then
		StaticPopup_Hide(which, data)

		EEAB.UseMouse = nil
		EEAB.ClearMouse()

		return
	end

	return EEAB.Hooked_StaticPopup_Show(which, text_arg1, text_arg2, data)
end

function EEAB.CoolSuitButton_Pickup(this)
	EEAB_CoolSuitButton_Pickup = this:GetID()

	EEAB.Hooked_CoolSuitButton_Pickup(this)
end

function EEAB.CoolClothBagItemButton_OnClick(this, button, ignoreShift)
	EEAB_CoolClothBagItemButton_OnClick_ID = this.index

	EEAB.Hooked_CoolClothBagItemButton_OnClick(this, button, ignoreShift)
end

function EEAB.CooldownFrame_SetTime_Hook(this, duration, remaining)
	if EEAB_Data and EEAB_Data.Options ~= nil and EEAB_Data.Options.cooldown then
		if duration > 0 or remaining > 0 then
			local text = ""

			if remaining >= 86400 then
				text = EEAB.floor(remaining / 86400, 1)..TEXT("UNIT_DAY")
			elseif remaining >= 3600 then
				text = EEAB.floor(remaining / 3600, 1)..TEXT("UNIT_HOUR")
			elseif remaining >= 60 then
				text = EEAB.floor(remaining / 60, 1)..TEXT("UNIT_MINUTE")
			elseif remaining > 1 then
				text = EEAB.floor(remaining, 1)
			end

			getglobal(this:GetName().."Text"):SetText(text)

			getglobal(this:GetName().."Texture"):SetCooldown(duration, remaining)

			this.starting = 1
			this.duration = duration
			this.remaining = remaining

			this:Show()
		else
			this:Hide()
		end
	else
		EEAB.Hooked_CooldownFrame_SetTime(this, duration, remaining)
	end
end
